\author{FTC 8798 Aluminati Industries \\ Ernest Barrington}

\date{8/1/2021}

% Preamble
\documentclass[11pt]{article}

% Packages
\usepackage{amsmath}

\usepackage{mdframed}
\usepackage{listings}
\usepackage{parskip}
\usepackage{xcolor}
\usepackage{indentfirst}
\title{Java Quickstart }


\definecolor{ngreen}{RGB}{163,190,140}
\definecolor{nblue}{RGB}{94,129,172}
\definecolor{ngray}{RGB}{76,86,106}
\definecolor{nred}{RGB}{191,97,106}
\definecolor{nblack}{RGB}{59,66,82}

\lstset {
    frame = tb,
    language=Java,
    aboveskip=3mm,
    belowskip=3mm,
    showstringspaces=false,
    numbers=left,
    stepnumber=1,
    columns=flexible,
    basicstyle={\small\ttfamily},
    numberstyle=\tiny\color{ngray},
    keywordstyle=\color{nblue},
    commentstyle=\color{ngray},
    stringstyle=\color{nred},
    breaklines=true,
    breakatwhitespace=true,
    tabsize=3
}
% Document
\begin{document}
    \maketitle



    \section{Introduction}
        This document provides a simple explanation of Java for coding FTC robots.
        This tutorial will not cover every part of java and you will likely be very confused after you read this tutorial
        and are thrusted into the world of FTC programming.
        However, there are many great resources that are available to you such as the FTC Subreddit,
        Youtube, Stack Exchange, and more.
        Never feel afraid to ask for help from others on these platforms because that is what they are for.
        Next, I highly recommend visiting our other tutorials that are publicy available on our Youtube Channel (It is in the project readme) and Gitlab group.


    \section{Prerequisites}
        For this tutorial you will need to have a couple programs installed on your computer .
        The first one is Android Studio which we will be using to write our code.
        The second one is Sourcetree which is completely optional, and I only recommend using
        if you want to use version control on your project.
        If you do use sourcetree I highly recommend making either a GitLab or GitHub account (I prefer GitLab).
        Lastly, you will need to install Git.
        The installation links will be provided in the project's README file.


    \section{Variables}
    The first thing we are going to look at is using variables in Java. A
    variable is used to store information such as numbers and text and can easily be reused throughout your code. The code below highlights the different types of variables in java.

    \begin {lstlisting}
        public class test {
            // This is a comment. Comments are ignored when the code is run.

            int sampleInt = 5; // Integers store positive and negative whole numbers.
            float sampleFloat = 5.3242; // Floats store positive and negative decimals up to 7 places.
            double sampleDouble = -5.3234243242; //  Stores numbers up to 15 decimal places.
            String sampleString = "Strings can store words!!!!";
            char character = 'x'; // Chars store single characters 
            boolean sampleBool = true; // Booleans are either true or false.

            //There are more variables in Java but these are the most common in FTC.
        }


    \end{lstlisting}
        Variables are declared with this syntax: "type name = value;" and they are extremely useful for storing
        data.
        Using variables will be discussed in the next section about the operators in java.

    \section{Operators}
        Operators are used to perform actions on variables in your code. 
        \subsection{Mathematical Operators} 
            \begin {center}
                \begin{tabular} {|c|c|c|}
                    
                    \hline 
                    Operator & Name & Description \\
                    + & Addition & Adds values \\
                    - & Subtraction & Subtracts values \\
                    * & Multiplication & Multiply values \\
                    / & Division & Divides values \\
                    \% & Modulus & Returns division remainder \\
                    ++ & Increment & Increments a value by 1 \\
                    -- & Decrement & Decreases a value by 1 \\
                    \hline 
                \end{tabular}
            \end{center}

        \subsection{Assignment Operators} 
            Assignment opertors are used to assign values to variables and offer a shorter way of making changes to variables. 
            \begin{center}
                \begin{tabular} {|c|c|c|}
                    \hline
                        Operator & Use & Extended Form \\
                        = & x = 1 & x = 1 \\
                        += & x += 1 & x = x + 1 \\
                        -= & x -= 1 & x = x - 1 \\
                        *=  & x *= 1 & x = x * 1 \\
                        /= & x /= 1 & x = x / 1 \\
                        \%= & x \%= 1 & x = x \% 1 \\
                        \textsuperscript{$\wedge$}= & x \textsuperscript{$\wedge$}= 1 & x = x \textsuperscript{$\wedge$} 1 \\
                    \hline
                \end{tabular}
            \end{center}

        \subsection{Logical Operators} 
            \begin{center}
                \begin {tabular} {|c|c|c|}
                    \hline
                        Operator & Name & Description \\
                        \&\& & And & Tests if two statements are true \\
                        $\vert$ $\vert$ & Or & Tests if one of the statements are true \\
                        ! & Not & Reverses results of a logical function. \\
                    \hline
                \end {tabular}
            \end {center}
        \subsection{Comparison Operators }
            \begin {center}
                \begin{tabular} {|c|c|}
                    \hline
                        Operator & Name / Function \\
                        == & Equality symbol  \\
                        != & Not Equal   \\
                        $>$ & Greater than  \\
                        $<$ & Lesser than  \\
                        $>$= & Greater than or equal to symbol   \\
                        $<$= &  Lesser than or equal to symbol. \\
                    \hline
                \end{tabular}
            \end{center}

    \section{Loops and Conditionals}
        \subsection {If Statements} 
        If statements are used to check if a condition is true or false. In the example listed below we will check if an integer is less than 5. 

            \begin {lstlisting}
import java.util.Scanner.*; 
public class Main {
    public static void main(String[] args) {
        Scanner input = new Scanner(System.in);
        System.out.println("Input a variable that is less than 5");
        int x = input.nextInt(); 
        if (x < 5 ) {
            System.out.println("Your input is less than 5. ");
            }
            else {
                System.out.println("You chose a number greater than 5. ");
            }
    }
}
            \end{lstlisting}
        \subsection {For Loops}
            There are two types of for loops in java. One is called a for each loop and the other is a traditional for loop. 

            \begin{lstlisting} 
public class Main {
    public static void main(String[] args) {
        //This first example is a for each loop. 
        int array[] = {1,2,3,4}; //This is an array and it is used to store multiple pieces of information in a single variable. 
        // For each integer in the array print out its value. 
        for (int i : array ) {
            System.out.println(i);
        }
                        
        // This example is a standard for loop. 
        // Every time x is less than 10 increase its value by 1 then print its value. 
        for (int x = 0; x < 10; x++) {
            System.out.println(x);
        }
    }
}
            \end{lstlisting}

        \subsection {While Loops}
            While loops perform an action until a condition is met. 
            
            \begin{lstlisting}
public class Main {
    public static void main(String[] args) {
        //This is an example of a do while loop. 
        int x = 0;
        do {
            x++;
            System.out.println(x);
        } while (x < 10);

        // Normal while loop
        while(x >= 10 && x < 20 ) {
            x++
            System.out.println("x has not reached its target value. " + x)
        }


    }    
}
            \end{lstlisting}

        \subsection{Switch Statements} 
        
        
        
        
        
        
    \section{Conclusion}


\end{document}
%TODO write paragraphs about each type of loop.
%TODO Fix title page, add table of contents, and an abstract. 
%TODO need to create a bibliography/works  cited page. 
%TODO: Format document. 
% TODO: Grammar and spelling checks. 
